Attribute VB_Name = "Module3"
Public Function fountain(ByRef resimg As imgdes) As Long
Dim rcode As Long
Dim k As Long
Dim j As Long
Dim rows As Long
Dim red As Byte
Dim grn As Byte
Dim blu As Byte
Dim newcolor As Long
Dim bmh As BITMAPINFOHEADER

getbmhfromimage bmh, resimg
rows = bmh.biHeight
If rows <= 1 Then GoTo bottom   ' Don't divide by zero

For k = resimg.sty To resimg.endy
    newcolor = (255 * k / (rows - 1))
    
    If bmh.biBitCount = 24 Then
        red = newcolor
        grn = newcolor
        blu = newcolor
        newcolor = RGB(red, grn, blu)
    End If
    
    For j = resimg.stx To resimg.endx
        rcode = setpixelcolor(resimg, j, k, newcolor)
    Next j
Next k

bottom:
    fountain = rcode

End Function

' Get BITMAPINFOHEADER from an image descriptor
Public Sub getbmhfromimage(newBmh As BITMAPINFOHEADER, image As imgdes)
    CopyMemory newBmh, image.bmh, 40   ' 40=size of BITMAPINFOHEADER
End Sub

Public Function goprint() As Long
Dim rcode As Long
Dim prtrect As RECT
    
    prtrect.left = 2000   ' two inches
    prtrect.top = 1000    ' one inch
    prtrect.right = prtrect.left + 3000 - 1     ' three inches wide
    prtrect.bottom = prtrect.top + (prtrect.right - prtrect.left + 1) * (vimage.endy - vimage.sty + 1) / (vimage.endx - vimage.stx + 1) ' Maintain aspect ratio

    ' Print some text
    Printer.ScaleMode = 5 ' Inches
    Printer.CurrentX = 2  ' One inch from left
    Printer.CurrentY = (prtrect.bottom + 1000 / 4) / 1000 ' 1/4 inch below picture
    Printer.Print "This is a Victor Library Image"
 
    rcode = printimagenoeject(hwnd, Printer.hdc, 0, vimage, prtrect, 0, 0)
    Printer.EndDoc

goprint = rcode
End Function

Public Function graytoblue(ByRef resimg As imgdes) As Long
Dim rcode As Long
Dim j As Integer
Dim colors As Long
Dim mypalette(0 To 255) As RGBQUAD

    colors = 256
    
    For j = 0 To (colors - 1)
        mypalette(j).rgbBlue = 255
        mypalette(j).rgbGreen = j
        mypalette(j).rgbRed = j
    Next j
    
    CopyPaletteFromRGBArraytoImage resimg.palette, mypalette(0), colors * 4
    rcode = updatebitmapcolortable(resimg)
       
    graytoblue = rcode
End Function

Public Function image_to_picturebox(srcimg As imgdes) As Picture
Dim retval As Long
Dim Pic As PicBmp
         ' IPicture requires a reference to "Standard OLE Types."
Dim IPic As IPicture
Dim IID_IDispatch As GUID
Dim tempimage As imgdes

    If (srcimg.hBitmap = 0) Then
        ' We have a packed dib, gotta make it a dib section-type of image
        rcode = dibtoimage(srcimg.bmh, tempimage)
            If rcode = NO_ERROR Then
                ' Replace previous image
                freeimage srcimg
                copyimgdes tempimage, srcimg
            End If
    End If

    ' Fill in with IDispatch Interface ID.
    With IID_IDispatch
        .Data1 = &H20400
        .Data4(0) = &HC0
        .Data4(7) = &H46
    End With
    
    ' Fill Pic with necessary parts.
    With Pic
        .Size = Len(Pic)          ' Length of structure.
        .Type = vbPicTypeBitmap   ' Type of Picture (bitmap).
        .hBmp = srcimg.hBitmap    ' Handle to bitmap.
        .hPal = 0                 ' Handle to palette (may be null).
    End With
    
    ' Create Picture object.
    retval = OleCreatePictureIndirect(Pic, IID_IDispatch, 1, IPic)
    
    If (retval = 0) Then
        Set image_to_picturebox = IPic
    End If

End Function






